=== debian/changelog ===
intel-processor-trace (2.1.2-3) unstable; urgency=medium

  * d/p/0001-cmake-bump-minimum-required-version.patch:
    Fix build with CMake 4.0. (Closes: #1113050)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Mon, 01 Sep 2025 16:51:11 -0400

intel-processor-trace (2.1.2-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Update lintian override info format in d/libipt2.lintian-overrides
    on line 1.
    Changes-By: lintian-brush
    Fixes: lintian: mismatched-override
    See-also: https://lintian.debian.org/tags/mismatched-override.html
  * Set upstream metadata fields: Bug-Submit.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    See-also:
    https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html

  [ Sergio Durigan Junior ]
  * d/control: Bump Standards-Version to 4.7.2; no changes needed.
  * d/control: Add Debian GDB Team as maintainer.
    Also, move Victor Seva to Uploaders.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 31 Aug 2025 16:17:40 -0400

intel-processor-trace (2.1.2-1) unstable; urgency=medium

  * New upstream version 2.1.2

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 25 Jan 2025 20:02:22 -0500
